unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Compress, ComCtrls, ShellAPI, Param, Menus, FileCtrl;

const
  MaxFreqMax = 1024 * 1024; // f[^̍őpx̍ől(̃f[^ł͂傫őpxe܂Aȏ傫鎖͏o܂B)

type
  TFrameForm = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Panel2: TPanel;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    GroupBox2: TGroupBox;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Button2: TButton;
    Button3: TButton;
    Label2: TLabel;
    Edit3: TEdit;
    UpDown3: TUpDown;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Button4: TButton;
    Label6: TLabel;
    Parameter1: TParameter;
    PopupMenu1: TPopupMenu;
    H1: TMenuItem;
    About1: TMenuItem;
    N1: TMenuItem;
    Q1: TMenuItem;
    A1: TMenuItem;
    N2: TMenuItem;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    GroupBox3: TGroupBox;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    UpDown4: TUpDown;
    UpDown5: TUpDown;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Edit13: TEdit;
    UpDown6: TUpDown;
    N3: TMenuItem;
    X1: TMenuItem;
    RadioButton5: TRadioButton;
    GroupBox4: TGroupBox;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure UpDown3Click(Sender: TObject; Button: TUDBtnType);
    procedure Edit3KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit4KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button4Click(Sender: TObject);
    procedure H1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Q1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure A1Click(Sender: TObject);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Edit7KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit8KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit9KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit10KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure X1Click(Sender: TObject);
    procedure Edit13KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RadioButton5Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private 錾 }
    procedure AcceptFiles(var Msg: TMessage); message WM_DROPFILES;
    procedure WMCopyData(var Msg: TWMCopyData); message WM_COPYDATA;
  public
    { Public 錾 }
    DataDir: String;
    LenD: Integer; // FrequencyD[] ̗Lvf
    LenF: Integer; // FrequencyF[] ̗Lvf
    EXD, VXD: Integer; // FrequencyD[] ̕ρEU
    EXF, VXF: Integer; // FrequencyF[] ̕ρEU
    Step: Integer; // _Ot{̕(1 ` 20)
    SIndex: Integer; // _Ot̕\JnCfbNX
    RLen: Integer; // ʂɕ\\Ȗ_Ot̖{
    Foot: Integer; // SIndex 𑝌ꍇɎgl
    MaxFreq: Integer; // FrequencyD[] y FrequencyF[] ̗vf̍ől
    iMaxFreq: Integer; // FrequencyD[]  MaxFreq ̃CfbNXԍ
    SNode: String; // nt}z̕\
    SArray: String; // nt}z BitPattern  BitLength ̔z̕\
    SFreq: String; // FrequencyD[] ̕\
    CurFile: String; // ݕ\Ăf[^̃t@C
    CurData: Integer; // ݕ\Ăvf̃f[^l
    FrequencyD: array of Integer; // pxf[^̏Ŋi[z(nt}͗p)
    FrequencyF: array of Integer; // pxpx̑傫Ŋi[z(nt}͗p)
    Normal: array of Integer; // Kz̒li[z
    Huffman: THuffman;
    Mf: TMetafile;
    procedure InitAll;
    procedure InitParameter;
    procedure SaveParameter;
    procedure GetData;
    procedure GetEXVX;
    procedure GetNormal;
    procedure DispBarGraph(const Frequency: array of Integer;
                           Len: Integer; // Frequency ̗Lvf
                           Index: Integer; // \JnCfbNX
                           Option: Boolean); // Kz`߂B
    procedure DispData;
    procedure LoadFromFile(FileName: String);
    procedure QuickSortFrequencyF(L, R: Integer);
    function HuffmanRate: String;
    function Stream2FrequencyD: Boolean;
    function FrequencyD2Stream: Boolean;
    function Huffman2FrequencyD: Boolean;
    function FrequencyD2FrequencyF: Boolean;
    function FrequencyTable(const Frequency: array of Integer; Len: Integer): String;
    function GetTotal(Frequency: array of Integer; L, R: Integer): Int64;
    function GetEX(Frequency: array of Integer; L, R: Integer): Integer;
    function GetVX(Frequency: array of Integer; L, R, EX: Integer): Integer;
    function GetpLeft(Frequency: array of Integer; Per: Integer): Integer;
    function GetpRight(Frequency: array of Integer; Per: Integer): Integer;
  end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

procedure TFrameForm.InitAll;
begin
  WindowState := wsNormal;
  Left := 197;
  Top := 115;
  ClientWidth := 711;
  ClientHeight := 515;
  X1.Checked := False;
  if RadioButton1.Checked = False then
  begin
    RadioButton1.Checked := True;
    DispBarGraph(FrequencyD, LenD, 0, False);
  end;
  if RadioButton3.Checked = False then
  begin
    RadioButton3.Checked := True;
    Memo1.Text := SNode;
  end;
  if UpDown1.Position <> 10 then
  begin
    UpDown1.Position := 10;
    Step := UpDown1.Position;
    if RadioButton1.Checked then
      DispBarGraph(FrequencyD, LenD, 0, False)
    else
      DispBarGraph(FrequencyF, LenF, 0, False);
  end;
  UpDown2.Position := 255;
  Caption := 'Huffman Generator Version 1.0';
end;

procedure TFrameForm.InitParameter;
begin
  { Parameter1 Ăep[^t@C烍[hB}
  Parameter1.Init;
  if Parameter1.Count > 0 then // p[^̃[hɐꍇ
  begin
    WindowState := TWindowState(Parameter1['WindowState']); // Integer ^̃f[^𓾂B
    if WindowState <> wsMaximized then
    begin
      Left := Parameter1['Left']; // Integer ^̃f[^𓾂B(Parameter1.VIntegers['Left'] ƓłB)
      Top := Parameter1['Top']; // Integer ^̃f[^𓾂B
      ClientWidth := Parameter1['ClientWidth']; // Integer ^̃f[^𓾂B
      ClientHeight := Parameter1['ClientHeight']; // Integer ^̃f[^𓾂B
    end;
    if Parameter1['Graph'] = 2 then RadioButton2.Checked := True
    else RadioButton1.Checked := True;
    if Parameter1['Infor'] = 3 then RadioButton5.Checked := True
    else if Parameter1['Infor'] = 2 then RadioButton4.Checked := True
    else RadioButton3.Checked := True;
    if Parameter1['Data'] = 2 then RadioButton7.Checked := True
    else RadioButton6.Checked := True;
    UpDown1.Position := Parameter1['UpDown1.Position']; // Integer ^̃f[^𓾂B
    UpDown2.Position := Parameter1['UpDown2.Position']; // Integer ^̃f[^𓾂B
    X1.Checked := Parameter1.VBools['X1.Checked']; // Boolean ^̃f[^𓾂B
  end
  else // p[^[hoȂꍇ
  begin
    Parameter1.Add('Huffman Generator ݒt@C --- ̃t@ĆAҏWȂŉB');
    Parameter1['WindowState'] := Integer(WindowState); // Integer ^̃f[^𓾂B
    Parameter1['Left'] := Left; // Integer ^̃f[^𓾂B(Parameter1.VIntegers['Left'] ƓłB)
    Parameter1['Top'] := Top; // Integer ^̃f[^𓾂B
    ClientWidth := 711; Parameter1['ClientWidth'] := ClientWidth; // Integer ^̃f[^𓾂B
    ClientHeight := 515; Parameter1['ClientHeight'] := ClientHeight; // Integer ^̃f[^𓾂B
    Parameter1['Graph'] := 1;
    Parameter1['Infor'] := 1;
    Parameter1['Data'] := 1;
    Parameter1['UpDown1.Position'] := UpDown1.Position; // Integer ^̃f[^𓾂B
    Parameter1['UpDown2.Position'] := UpDown2.Position; // Integer ^̃f[^𓾂B
    Parameter1.VBools['X1.Checked'] := X1.Checked; // Boolean ^̃f[^𓾂B
  end;
end;

procedure TFrameForm.SaveParameter;
begin
  Parameter1['WindowState'] := Integer(WindowState);
  if WindowState <> wsMaximized then
  begin
    Parameter1['Left'] := Left; // Integer ^̃f[^𓾂B(Parameter1.VIntegers['Left'] ƓłB)
    Parameter1['Top'] := Top; // Integer ^̃f[^𓾂B
    Parameter1['ClientWidth'] := ClientWidth; // Integer ^̃f[^𓾂B
    Parameter1['ClientHeight'] := ClientHeight; // Integer ^̃f[^𓾂B
    if RadioButton2.Checked then Parameter1['Graph'] := 2
    else Parameter1['Graph'] := 1;
    if RadioButton5.Checked then Parameter1['Infor'] := 3
    else if RadioButton4.Checked then Parameter1['Infor'] := 2
    else Parameter1['Infor'] := 1;
    if RadioButton7.Checked then Parameter1['Data'] := 2
    else Parameter1['Data'] := 1;
    Parameter1['UpDown1.Position'] := UpDown1.Position; // Integer ^̃f[^𓾂B
    Parameter1['UpDown2.Position'] := UpDown2.Position; // Integer ^̃f[^𓾂B
    Parameter1.VBools['X1.Checked'] := X1.Checked; // Boolean ^̃f[^𓾂B
  end;

  Parameter1.SaveToFile;
end;

{ dNh~ׂ̎葱łB}

procedure TFrameForm.WMCopyData(var Msg: TWMCopyData);
var
  S : String;
begin
  if (not X1.Checked) and // dNȂꍇ
     (Msg.CopyDataStruct.dwData = 1024) then // lʎq
  begin
    S := PChar(Msg.CopyDataStruct.lpData);
    if S = 'CPS03' then // ʎq
      Application.Terminate;
  end;
end;

{ Huffman ݂̌̈k_ȉ 1 ܂ŕ\킷ŕԂ֐łB }

function TFrameForm.HuffmanRate: String;
var
  i: Integer;
  X, Y: Int64;
begin
  Result := '';
  X := 0; Y := 0;

  for i := 0 to Huffman.NCount - 1 do
  begin
    X := X + Huffman.Nodes[i].Frequency * 8;
    Y := Y + Huffman.Nodes[i].Frequency * Huffman.Nodes[i].BitLength;
  end;

  Result := Format('%2.1f', [Y * 100 / X]);
end;

{ Huffman.InStream ̃f[^ 32 bit ̕pxf[^Ƃ݂ȂāAFrequencyD[] }
{ Ɋi[֐łB True s False Ԃ܂B }
{ ֐ł FrequencyD[] ̃TCY߂ LenD  MaxFreq  iMaxFreq  }
{ l߂܂B}

function TFrameForm.Stream2FrequencyD: Boolean;
var
  i, j, n, X: Integer;
begin
  Result := False;
  LenD := 0; MaxFreq := 0; iMaxFreq := 0;
  SetLength(FrequencyD, 0);
  if (Huffman.InStream.Size = 0) or (Huffman.InStream.Size > 40 * 1024) then
    Exit;

  n := SizeOf(Integer);
  LenD := Huffman.InStream.Size div n;
  if Huffman.InStream.Size mod n <> 0 then
    Inc(LenD);

  SetLength(FrequencyD, LenD);
  Huffman.InStream.Position := 0;
  j := 0;
  for i := 0 to LenD - 1 do
  begin
    Huffman.InStream.Read(X, n);
    if (X < 0) or (X > MaxFreqMax) then
    begin
      j := -1; // G[
      Break;
    end
    else if X > 0 then
    begin
      j := i + 1;
      if X > MaxFreq then
      begin
        MaxFreq := X;
        iMaxFreq := i;
      end;
    end;
    FrequencyD[i] := X;
  end;

  if j = -1 then // G[
    LenD := 0
  else
  begin
    LenD := j; // LenD = 0 Ȃ킿Svf 0 łĂ FrequencyD[] 
    Result := True; // f[^͂Ă̂܂܂ɂAG[ɂ͂ȂB
  end;
end;

{ z̗vfꗗ\`̕ɂ Len Ԃ֐łB}
{ 10 i 16 i𕹋Lĕ\܂B}

function TFrameForm.FrequencyTable(const Frequency: array of Integer; Len: Integer): String;
var
  i, n: Integer;
  V: String;
begin
  Result := '';
  n := Length(Frequency);
  if n = 0 then
    Exit;

  if Len > n then
    Len := n;

  V := '================================================' + #13#10;
  V := V + '        Data:       |      Frequency:' + #13#10;
  V := V + '================================================' + #13#10;
  for i := 0 to Len - 1 do
    V := V + Format('%8d  =  $%x     | %8d  =  $%x', [i, i, Frequency[i], Frequency[i]]) + #13#10;
  V := V + #13#10;

  Result := V;
end;

{ FrequencyF[]  L ` R Ԃŕpx̑傫ɃNCbN\[g葱łB}

procedure TFrameForm.QuickSortFrequencyF(L, R: Integer);
var
  I, J, P: Integer;
  V: Integer;
begin
  repeat
    I := L;
    J := R;
    P := (L + R) shr 1;
    repeat
      while FrequencyF[I] > FrequencyF[P] do Inc(I);
      while FrequencyF[J] < FrequencyF[P] do Dec(J);
      if I <= J then
      begin
        V := FrequencyF[I];
        FrequencyF[I] := FrequencyF[J];
        FrequencyF[J] := V;
        if P = I then
          P := J
        else if P = J then
          P := I;
        Inc(I);
        Dec(J);
      end;
    until I > J;
    if L < J then QuickSortFrequencyF(L, J);
    L := I;
  until I >= R;
end;

{ FrequencyD[] ̑SẴf[^ 32 bit ̒ʏf[^ɕϊ Huffman.InStream }
{ Ɋi[֐łB True s False Ԃ܂B̊֐ }
{ ł LenD  MaxFreq   iMaxFreq ̒l߂܂B}

function TFrameForm.FrequencyD2Stream: Boolean;
var
  i, j, n, X: Integer;
begin
  Result := False;
  Huffman.Clear;
  if Length(FrequencyD) = 0 then
    Exit;

  MaxFreq := 0; iMaxFreq := 0;
  j := 0; n := SizeOf(Integer);
  for i := 0 to Length(FrequencyD) - 1 do
  begin
    X := FrequencyD[i];
    Huffman.InStream.Write(X, n);
    if X > 0 then
    begin
      j := i + 1;
      if X > MaxFreq then
      begin
        MaxFreq := X;
        iMaxFreq := i;
      end;
    end;
  end;
  LenD := j; // Lvf
  Result := True;
end;

{  Huffman Ɋi[Ănt}f[^̕pxf[^ }
{  FrequencyD[] ̃CfbNX 0 ` 255 ܂ł̊ԂɊi[֐łB }
{  True s False Ԃ܂B̊֐ł LenD  MaxFreq }
{  iMaxFreq ̒l߂܂B}

function TFrameForm.Huffman2FrequencyD: Boolean;
var
  i, j: Integer;
begin
  Result := False;
  if (Huffman.NCount = 0) or (Length(FrequencyD) < Huffman.NCount) then
    Exit;

  for i := 0 to Huffman.NCount - 1 do
  begin
    j := Huffman.Nodes[i].Data;
    FrequencyD[j] := Huffman.Nodes[i].Frequency;
  end;

  LenD := 0; MaxFreq := 0; iMaxFreq := 0;
  for i := 0 to Length(FrequencyD) - 1 do
  begin
    if FrequencyD[i] > 0 then
    begin
      LenD := i + 1;
      if FrequencyD[i] > MaxFreq then
      begin
        MaxFreq := FrequencyD[i];
        iMaxFreq := i;
      end;
    end;
  end;
  Result := True;
end;

{ FrequencyD[] ̃f[^ FrequencyF[] ɃRs[Ăpx̑傫 }
{ Ƀ\[g֐łB True s False Ԃ܂B}
{ ̊֐ł FrequencyF[] ̃TCY߂ LenF ̒l߂܂B}

function TFrameForm.FrequencyD2FrequencyF: Boolean;
var
  i, n: Integer;
begin
  Result := False;
  n := Length(FrequencyD);
  if n = 0 then
    Exit;

  SetLength(FrequencyF, n);
  for i := 0 to n - 1 do
    FrequencyF[i] := FrequencyD[i];

  QuickSortFrequencyF(0, n - 1);

  LenF := 0;
  for i := n - 1 downto 0 do
  begin
    if FrequencyF[i] <> 0 then
    begin
      LenF := i + 1;
      Break;
    end;
  end;

  Result := True
end;

{ ^ꂽςƕU̒l琳Kz̒l Normal[] ɓ葱łB}

procedure TFrameForm.GetNormal;
var
  i, n, EX, VX, MaxY: Integer;
  X: Real;
begin
  n := Length(FrequencyD);
  SetLength(Normal, n);
  if n = 0 then
    Exit;

  for i := 0 to n - 1 do
    Normal[i] := 0;

  EX := UpDown4.Position; // ݂̕ϒl
  VX := UpDown5.Position; // ݂̕Ul
  MaxY := StrToInt(Edit13.Text); // ݂̍ől = UpDown6.Position
  if VX = 0 then
  begin
    if MaxY = 0 then Exit
    else VX := 1; // bI 1 ɂĒuB
  end;

  for i := 0 to n - 1 do
  begin
    X := i - EX;
    X := X * X;
    X := X / (2 * VX);
    X := MaxY * Exp(-X);
    Normal[i] := Round(X);
    if (Normal[i] = 0) and (i > 0) and (Normal[i - 1] <> 0) then
      Break;
  end;
end;

{ FrequencyD[]  FrequencyF[] ̕ςƕU߂葱łB}

procedure TFrameForm.GetEXVX;
var
  i, N: Integer; // f[^
  X, Sumv: Int64;
begin
  if LenD = 0 then
  begin
    EXD := 0; VXD := 0;
    EXF := 0; VXF := 0;
    Exit;
  end;

  { FrequencyD[] ̕ςƕU߂B}

  N := 0; Sumv := 0;
  for i := 0 to LenD - 1 do
  begin
    N := N + FrequencyD[i];
    Sumv := Sumv + i * FrequencyD[i];
  end;
  EXD := Sumv div N; // FrequencyD[] ̕

  Sumv := 0;
  for i := 0 to LenD - 1 do
  begin
    X := (i - EXD) * (i - EXD) * FrequencyD[i];
    Sumv := Sumv + X;
  end;
  VXD := Sumv div N;

  { FrequencyF[] ̕ςƕU߂B}

  N := 0; Sumv := 0;
  for i := 0 to LenF - 1 do
  begin
    N := N + FrequencyF[i];
    Sumv := Sumv + i * FrequencyF[i];
  end;
  EXF := Sumv div N; // FrequencyF[] ̕

  Sumv := 0;
  for i := 0 to LenF - 1 do
  begin
    X := (i - EXF) * (i - EXF) * FrequencyF[i];
    Sumv := Sumv + X;
  end;
  VXF := Sumv div N;
end;

procedure TFrameForm.GetData;
var
  S: String;
begin
  FrequencyD2FrequencyF; // FrequencyD[]  FrequencyF[] ɃRs[ĂpxɃ\[gB

  UpDown2.Position := Length(FrequencyD) - 1;

  GetEXVX; // FrequencyD[]  FrequencyF[] ̕ςƕU߂B

  if RadioButton1.Checked then
  begin
    UpDown4.Position := EXD;
    Label9.Caption := IntToStr(EXD);
    UpDown5.Position := VXD;
    Label10.Caption := IntToStr(VXD);
    Edit13.Text := IntToStr(MaxFreq); // UpDown6.Position := MaxFreq;
    Label12.Caption := IntToStr(MaxFreq);
  end
  else
  begin
    UpDown4.Position := EXF;
    Label9.Caption := IntToStr(EXF);
    UpDown5.Position := VXF;
    Label10.Caption := IntToStr(VXF);
    Edit13.Text := IntToStr(MaxFreq); // UpDown6.Position := MaxFreq;
    Label12.Caption := IntToStr(MaxFreq);
  end;

  S := 't@C = ' + ExtractFileName(CurFile) + #13#10;
  if LenD = 0 then
  begin
    S := S + #13#10 + 'nt}쐬oȂׁA' + #13#10+ #13#10;
    SNode := S + 'nt}z͕\o܂B';
    SArray := S + 'nt}z͕\o܂B';
  end
  else
  begin
    S := S + 'nt}ɂ鈳k = ' + HuffmanRate + ' %' + #13#10 + #13#10;
    SNode := S + '<f[^̃nt}z>' + #13#10 + GeneralNode(FrequencyD, 256);
    SArray := S + GeneralArray(FrequencyD, 256, '');
  end;

  S := 't@C = ' + ExtractFileName(CurFile) + #13#10 + #13#10;
  SFreq := S + '<f[^̕pxe[u>   10 i  =  16 i\' + #13#10 +
           FrequencyTable(FrequencyD, Length(FrequencyD));
end;

procedure TFrameForm.DispBarGraph(const Frequency: array of Integer;
                                  Len: Integer; // Frequency ̗Lvf
                                  Index: Integer; // \JnCfbNX
                                  Option: Boolean); // Kz`߂B
var
  i, n: Integer;
  W, X, Y: Integer;
  F, G, G0, H: Integer;
  S: String;
  MfCanvas: TMetafileCanvas;
begin
  if (Length(Frequency) = 0) or (Len <= 0) or (Len > Length(Frequency)) or
     (Index < 0) or (Index > Len - 1) then
  begin
    Image1.Picture.Graphic := Nil;
    Button9.Enabled := False;
    Button10.Enabled := False;
    Button11.Enabled := False;
    Button12.Enabled := False;
    Exit;
  end;

  Step := UpDown1.Position; // _Ot{̕(1 ` 20)
  RLen := (Image1.Width - (24 + 10 + 2)) div Step; // ʂɕ\\Ȗ_Ot̖{
  { ۂɕ\_Ot̖{ n ߂B}
  n := Len - Index;
  if n > RLen then
    n := RLen; 

  try
    X := StrToInt(Edit13.Text);
  except
    X := MaxFreq;
    Edit13.Text := IntToStr(X);
  end;

  if X > 32767 then
    UpDown6.Associate := Nil
  else
  begin
    UpDown6.Associate := Edit13;
    UpDown6.Position := X;
  end;

  { ^t@CB}
  Mf.Clear;
  Mf.Width := Image1.Width;
  Mf.Height := Image1.Height;

  MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
  try
    { wi`B}
    MfCanvas.Brush.Color := clBtnFace;
    MfCanvas.Pen.Color := clBtnFace;
    MfCanvas.Rectangle(0, 0, Image1.Width, Image1.Height);

    { X  Y `B}
    MfCanvas.Pen.Color := clBlack;
    MfCanvas.MoveTo(24 + 10, 8);
    MfCanvas.LineTo(24 + 10, Image1.Height - 14);
    MfCanvas.LineTo(24 + 10 + 2 + Step * n, Image1.Height - 14);

    { Y ̖ڐ`B}
    F := 10;
    while (MaxFreq div F) <> 0 do
      F := F * 10;
    F := F div 10;
    if F = 1 then // MaxFreq < 10 ̏ꍇ
    begin
      if MaxFreq > 7 then
        F := 2
    end
    else if MaxFreq div F = 1 then
      F := F div 5
    else if MaxFreq > F * 7 then
      F := F * 2;

    G := 0;
    Y := Image1.Height - (14 + 2);
    while G < MaxFreq do
    begin
      X := 24 + 10 - 4;
      S := IntToStr(G); W := MfCanvas.TextWidth(S);
      H := (Image1.Height - (8 + 2 + 14)) * G div MaxFreq;
      MfCanvas.MoveTo(X, Y - H); MfCanvas.LineTo(X + 4, Y - H);
      X := X - W; if X < 0 then X := 0;
      MfCanvas.TextOut(X, Y - H - 5, S);
      G := G + F;
    end;

    X := 24 + 10 - 4;
    S := IntToStr(MaxFreq); W := MfCanvas.TextWidth(S);
    MfCanvas.MoveTo(X, 8); MfCanvas.LineTo(X + 4, 8);
    X := X - W; if X < 0 then X := 0;
    MfCanvas.TextOut(X, 8 - 5, IntToStr(MaxFreq));

    { X ̖ڐ`B}
    if Step > 5 then
      F := 16
    else
      F := 32;

    Foot := RLen div F * F; // SIndex 𑝌ꍇɎgl

    G := Index div F * F;
    G0 := G; // ŏ G ̒l
    X := 24 + 10 + 2 + (Step div 2);
    Y := Image1.Height - 14;
    while G < Index + n do
    begin
      S := IntToStr(G); W := MfCanvas.TextWidth(S);
      MfCanvas.MoveTo(X + (G - G0) * Step, Y);
      MfCanvas.LineTo(X + (G - G0) * Step, Y + 3);
      MfCanvas.TextOut(X + (G - G0) * Step - (W div 2), Y + 3, S);
      G := G + F;
    end;

    if Index + n = Len then
    begin
      S := IntToStr(Len - 1); W := MfCanvas.TextWidth(S);
      MfCanvas.MoveTo(X + (Len - 1 - G0) * Step, Y);
      MfCanvas.LineTo(X + (Len - 1 - G0) * Step, Y + 3);
      MfCanvas.TextOut(X + (Len - 1 - G0) * Step - (W div 2), Y + 3, S);
    end;

    { Ŗ_Ot`B}
    MfCanvas.Brush.Color := clBlue;
    MfCanvas.Pen.Color := clWhite;

    X := 24 + 10 + 2;
    Y := Image1.Height - (14 + 2);
    for i := Index to Index + n - 1 do
    begin
      H := (Image1.Height - (8 + 2 + 14)) * Frequency[i] div MaxFreq;
      if Step <= 3 then
        MfCanvas.FillRect(Rect(X, Y - H, X + Step, Y))
      else
        MfCanvas.Rectangle(X, Y - H, X + Step, Y);
      X := X + Step;
    end;
    Button9.Enabled := True;

    { Kz`B}
    if Option and (MaxFreq > 0) and (LenD > 0) then
    begin
      GetNormal; // Normal[] ɐKz̒li[B
      MfCanvas.Pen.Color := clRed;
      MfCanvas.Pen.Width := 2;
      X := 24 + 10 + 2 + (Step div 2);
      H := (Image1.Height - (8 + 2 + 14)) * Normal[Index] div MaxFreq;
      MfCanvas.MoveTo(X, Y - H);
      for i := Index + 1 to Index + n - 1 do
      begin
        X := X + Step;
        H := (Image1.Height - (8 + 2 + 14)) * Normal[i] div MaxFreq;
        MfCanvas.LineTo(X, Y - H);
      end;
      Button10.Enabled := True;
      Button11.Enabled := True;
      Button12.Enabled := True;
    end;
  finally
    MfCanvas.Free; // JĂ͂߂ăC[W\B
  end;

  { `̑傫XN[foCXɂ悤ɂB(Inch <> 0) }
  Mf.Inch := 1;
  Image1.Picture.Graphic := Mf;

  SIndex := Index;
  if SIndex = 0 then
    Button13.Enabled := False
  else
    Button13.Enabled := True;

  if SIndex + RLen - 1 >= Len - 1 then
    Button14.Enabled := False
  else
    Button14.Enabled := True;
end;

procedure TFrameForm.DispData;
var
  i, j, Len: Integer;
begin
  Len := Length(FrequencyD);
  if Len = 0 then
    Exit;

  i := UpDown3.Position;
  Label6.Caption := '= $' + IntToHex(i, 2);

  if i < Len then
    Edit4.Text := IntToStr(FrequencyD[i])
  else
    Edit4.Text := ''; // f[^݂ȂGA

  j := 0;
  while (j < Huffman.NCount) and (Huffman.Nodes[j].Data <> i) do
    Inc(j);
  if j < Huffman.NCount then
  begin
    Edit5.Text := IntToStr(Huffman.Nodes[j].BitLength);
    Edit6.Text := IntToBin(Huffman.Nodes[j].BitPattern, Huffman.Nodes[j].BitLength) +
                ' = ' + IntToStr(Huffman.Nodes[j].BitPattern);
  end
  else // f[^݂ȂGA
  begin
    Edit5.Text := '';
    Edit6.Text := '';
  end;

  CurData := i;
end;

procedure TFrameForm.LoadFromFile(FileName: String);
var
  i: Integer;
  S: String;
begin
  UpDown3.Position := 0;

  if not FileExists(FileName) then
  begin
    ShowMessage(FileName + ' ͌܂B');
    Exit;
  end;

  Huffman.InStream.LoadFromFile(FileName);
  if Huffman.InStream.Size = 0 then
  begin
    ShowMessage('TCY 0 ̃t@C͕\o܂B');
    Exit;
  end;

  CurFile := FileName; CurData := 0;
  LenD := 0; LenF := 0; MaxFreq := 0;
  SNode := ''; SArray := ''; SFreq := '';

  Caption := 'Huffman Generator Version 1.0 EEE nt}쐬Ă܂B';

  if RadioButton7.Checked then // 32 bit gf[^
  begin
    if Stream2FrequencyD = False then  // G[
    begin
      S := #13#10 + 't@C ' + CurFile +
           #13#10 + #13#10 +
           'Ɋ܂܂f[^ 32 bit ̊gf[^ƂĈȂ' +
           #13#10 + #13#10 +
           'Ă܂̂ŁA8 bit ̒ʏf[^ƂĈ܂B' + #13#10;
      ShowMessage(S);
      RadioButton6.Tag := 1; // RadioButton6Click ŉȂlɂB
      RadioButton6.Checked := True;
    end
    else
      Huffman.Ennode;
  end;

  if RadioButton6.Checked then // 8 bit ʏf[^
  begin
    LenD := 256;
    SetLength(FrequencyD, LenD);
    for i := 0 to LenD - 1 do
      FrequencyD[i] := 0; // 
    Huffman.Encode;
    Huffman2FrequencyD;
  end;

  GetData;

  Caption := 'Huffman Generator Version 1.0';

  if RadioButton1.Checked then
    DispBarGraph(FrequencyD, LenD, 0, False)
  else
    DispBarGraph(FrequencyF, LenF, 0, False);

  if RadioButton3.Checked then
    Memo1.Text := SNode
  else if RadioButton4.Checked then
    Memo1.Text := SArray
  else
    Memo1.Text := SFreq;

  DispData;
  Button10.Enabled := False;
  Button11.Enabled := False;
  Button12.Enabled := False;
end;

procedure TFrameForm.FormShow(Sender: TObject);
var
  i, b: Integer;
  S, FileName: String;
begin
  S := '';
  FileName := '';
  Huffman := THuffman.Create;
  Mf := TMetafile.Create;
  CurFile := ''; CurData := 0;
  LenD := 0; LenF := 0; MaxFreq := 0;

  DataDir := ExtractFilePath(Application.ExeName) + 'HuffmanData';
  if not DirectoryExists(DataDir) then
    CreateDir(DataDir);

  InitParameter;

  { tH[ւ̃hbOhbvB}
  DragAcceptFiles(Handle, True);

  for i := 1 to ParamCount do
  begin
    if ParamStr(i)[1] = '/' then // NIvVXCb`
    begin
      if UpCase(ParamStr(i)[2]) = 'G' then
      begin
        if ParamStr(i)[3] = '2' then RadioBUtton2.Checked := True
        else RadioBUtton1.Checked := True;
      end
      else if UpCase(ParamStr(i)[2]) = 'I' then
      begin
        if ParamStr(i)[3] = '3' then RadioBUtton5.Checked := True
        else if ParamStr(i)[3] = '2' then RadioBUtton4.Checked := True
        else RadioBUtton3.Checked := True;
      end
      else if UpCase(ParamStr(i)[2]) = 'D' then
      begin
        if ParamStr(i)[3] = '2' then RadioBUtton7.Checked := True
        else RadioBUtton6.Checked := True;
      end
      else if UpCase(ParamStr(i)[2]) = 'B' then
      begin
        try
          b := StrToInt(Copy(ParamStr(i), 3, 2));
        except
          b := 10;
        end;
        UpDown1.Position := b;
      end;
    end
    else if S = '' then S := ParamStr(i);
  end;

  if S = '' then
  begin
    FileName := ExtractFilePath(Application.ExeName) + 'ReadmeH.txt';
    Memo1.Lines.LoadFromFile(FileName);
  end
  else
  begin
    if not ShortNameToLongName(S, FileName) then // 8.3 `̒Zt@C𒷂t@CɂB
      FileName := S;
    LoadFromFile(FileName);
  end;
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  SetLength(Normal, 0);
  SetLength(FrequencyF, 0);
  SetLength(FrequencyD, 0);
  Mf.Free;
  Huffman.Free;
  SaveParameter;
end;

procedure TFrameForm.AcceptFiles(var Msg: TMessage);
var
  Count: Integer;
  S: String;
  Buf: array[0..255] of Char;
begin
  S := '';
  { hbvꂽt@C̐擾B}
  Count := DragQueryFile(Msg.WParam, $FFFFFFFF, Buf, 255);
  { hbvꂽt@CtpXŎ擾B}
  if Count > 0 then
  begin
    DragQueryFile(Msg.WParam, 0, Buf, 255); // 擾B
    if not ShortNameToLongName(Buf, S) then // 8.3 `̒Zt@C𒷂t@CɂB
      S := String(Buf);
  end;
  DragFinish(Msg.WParam);

  if S <> '' then
    LoadFromFile(S);
end;

procedure TFrameForm.Button1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := DataDir;
  if OpenDialog1.Execute then
    LoadFromFile(OpenDialog1.FileName);
end;

procedure TFrameForm.RadioButton1Click(Sender: TObject);
begin
  UpDown4.Position := EXD;
  Label9.Caption := IntToStr(EXD);
  UpDown5.Position := VXD;
  Label10.Caption := IntToStr(VXD);
  Edit13.Text := IntToStr(MaxFreq); // UpDown6.Position := MaxFreq;
  Label12.Caption := IntToStr(MaxFreq);
  DispBarGraph(FrequencyD, LenD, 0, False);
end;

procedure TFrameForm.RadioButton2Click(Sender: TObject);
begin
  UpDown4.Position := EXF;
  Label9.Caption := IntToStr(EXF);
  UpDown5.Position := VXF;
  Label10.Caption := IntToStr(VXF);
  Edit13.Text := IntToStr(MaxFreq); // UpDown6.Position := MaxFreq;
  Label12.Caption := IntToStr(MaxFreq);
  DispBarGraph(FrequencyF, LenF, 0, False);
end;

procedure TFrameForm.RadioButton3Click(Sender: TObject);
begin
  Memo1.Text := SNode;
end;

procedure TFrameForm.RadioButton4Click(Sender: TObject);
begin
  Memo1.Text := SArray;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
var
  i, j, n: Integer;
begin
  j := Length(FrequencyD);
  n := UpDown2.Position + 1;
  if j >= n then
  begin
    i := 0;
    while i < n do
    begin
      if FrequencyD[i] = 0 then
        Break;
      Inc(i);
    end;
    if i = n then // 0 ̗vfȂB
      Exit;
  end;

  if j < n then
  begin
    SetLength(FrequencyD, n);
    for i := j to n - 1 do
      FrequencyD[i] := 0;
  end;

  for i := 0 to n - 1 do
    FrequencyD[i] := FrequencyD[i] + 1; // 0 ` UpDown2.Position  0 ̗vfȂB

  Button4Click(Sender);
end;

procedure TFrameForm.Button3Click(Sender: TObject);
begin
  if CurFile <> '' then
    LoadFromFile(CurFile);
end;

procedure TFrameForm.UpDown3Click(Sender: TObject; Button: TUDBtnType);
begin
  DispData;
end;

procedure TFrameForm.Edit3KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i: Integer;
begin
  if Key = $0D then
  begin
    try
      i := StrToInt(Edit3.Text);
    except
      i := -1;
    end;

    if (i < 0) or  (i > 10239) then
    begin
      ShowMessage(Edit3.Text + ' ͎wo܂B');
      Edit3.Text := IntToStr(CurData);
      Exit;
    end;

    UpDown3.Position := i;
    DispData
  end;
end;

procedure TFrameForm.Edit4KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i, j, X: Integer;
  S: String;
begin
  if Key = $0D then
  begin
    i := UpDown3.Position;
    j := Length(FrequencyD);
    if i < j then
      S := IntToStr(FrequencyD[i])
    else
      S := '';

    try
      X := StrToInt(Edit4.Text);
    except
      X := -1;
    end;

    if (X < 0) or (X > MaxFreqMax) then
    begin
      ShowMessage(Edit4.Text + ' ͎wo܂B');
      Edit4.Text := S;
      Exit;
    end;

    if j < i + 1 then
    begin
      SetLength(FrequencyD, i + 1);
      while j < i do
      begin
        FrequencyD[j] := 0;
        Inc(j);
      end;
    end;
    FrequencyD[i] := X;
    Button4Click(Sender); // XVĂSĂ̏\܂B
  end;
end;

{ XVĂSĂ̏\܂B}

procedure TFrameForm.Button4Click(Sender: TObject);
begin
  if Length(FrequencyD) = 0 then
    Exit;

  Caption := 'Huffman Generator Version 1.0 EEE nt}쐬Ă܂B';
  FrequencyD2Stream;
  Huffman.Ennode;
  GetData;
  Caption := 'Huffman Generator Version 1.0';

  if RadioButton1.Checked then
    DispBarGraph(FrequencyD, LenD, 0, False)
  else
    DispBarGraph(FrequencyF, LenF, 0, False);

  if RadioButton3.Checked then
    Memo1.Text := SNode
  else if RadioButton4.Checked then
    Memo1.Text := SArray
  else
    Memo1.Text := SFreq;

  DispData;
  Button10.Enabled := False;
  Button11.Enabled := False;
  Button12.Enabled := False;
end;

procedure TFrameForm.H1Click(Sender: TObject);
var
  FileName: TFileName;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'ReadmeH.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.About1Click(Sender: TObject);
begin
  ShellAbout(Handle, PChar(Application.Title),
             #13#10 + 'Huffman Generator Version 1.0 Copyright (C) 2020 ` 2021 seizo',
             Application.Icon.Handle);
end;

procedure TFrameForm.Q1Click(Sender: TObject);
begin
  ShowMessage('Huffman Generator Ԃɖ߂܂B');
  InitAll;
  SaveParameter;
end;

procedure TFrameForm.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i: Integer;
begin
  if Key = $0D then
  begin
    try
      i := StrToInt(Edit1.Text);
    except
      i := -1;
    end;

    if not (i in [1..20]) then
    begin
      ShowMessage(Edit1.Text + ' ͎wo܂B');
      UpDown1.Position := Step;
      Edit1.Text := IntToStr(Step);
      Exit;
    end;

    UpDown1.Position := i;
    Edit1.Text := IntToStr(i);
    Step := UpDown1.Position;
    if RadioButton1.Checked then
      DispBarGraph(FrequencyD, LenD, 0, False)
    else
      DispBarGraph(FrequencyF, LenF, 0, False);
  end;
end;

{ _Ot\B}

procedure TFrameForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  Step := UpDown1.Position;
  if RadioButton1.Checked then
    DispBarGraph(FrequencyD, LenD, 0, False)
  else
    DispBarGraph(FrequencyF, LenF, 0, False);
end;

procedure TFrameForm.A1Click(Sender: TObject);
begin
  Memo1.SelectAll;
end;

procedure TFrameForm.Edit2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i: Integer;
begin
  if Key = $0D then
  begin
    try
      i := StrToInt(Edit2.Text);
    except
      i := -1;
    end;

    if (i < 0) or (RadioButton6.Checked and (i > 255)) or
       (RadioButton7.Checked and (i > 10239)) then
    begin
      ShowMessage(Edit2.Text + ' ͎wo܂B');
      Edit2.Text := IntToStr(Length(FrequencyD) - 1);
      Exit;
    end;

    UpDown2.Position := i;
    Edit2.Text := IntToStr(i);
  end;
end;

procedure TFrameForm.Button5Click(Sender: TObject);
var
  i, j, n, V, Maxx: Integer;
begin
  if Length(FrequencyD) < UpDown2.Position + 1 then
    n := Length(FrequencyD)
  else
    n := UpDown2.Position + 1;

  Maxx := 0;
  for i := 0 to n - 1 do
  begin
    if FrequencyD[i] > Maxx then
      Maxx := FrequencyD[i];
  end;

  try
    V := StrToInt(Edit7.Text);
  except
    V := 0;
  end;

  if (V <= 0) or (Maxx + V > MaxFreqMax) then
  begin
    ShowMessage(Edit7.Text + ' 𑫂͏o܂B');
    Edit7.Text := '1';
    Exit;
  end;

  j := Length(FrequencyD);
  n := UpDown2.Position + 1;

  if j < n then
  begin
    SetLength(FrequencyD, n);
    for i := j to n - 1 do
      FrequencyD[i] := 0; // 
  end;

  for i := 0 to n - 1 do
    FrequencyD[i] := FrequencyD[i] + V; // 0 ` UpDown2.Position ̗vf V 𑫂B

  Button4Click(Sender);
end;

procedure TFrameForm.Button6Click(Sender: TObject);
var
  i, j, n, V: Integer;
begin
  try
    V := StrToInt(Edit8.Text);
  except
    V := 0;
  end;

  if V <= 0 then
  begin
    ShowMessage(Edit8.Text + ' ͏o܂B');
    Edit8.Text := '1';
    Exit;
  end;

  j := Length(FrequencyD);
  n := UpDown2.Position + 1;

  if j < n then
  begin
    SetLength(FrequencyD, n);
    for i := j to n - 1 do
      FrequencyD[i] := 0; // 
  end;

  for i := 0 to n - 1 do
  begin
    FrequencyD[i] := FrequencyD[i] - V; // 0 ` UpDown2.Position ̗vf V B
    if FrequencyD[i] < 0 then
      FrequencyD[i] := 0;
  end;

  Button4Click(Sender);
end;

procedure TFrameForm.Button7Click(Sender: TObject);
var
  i, j, n, V, Maxx: Integer;
begin
  if Length(FrequencyD) < UpDown2.Position + 1 then
    n := Length(FrequencyD)
  else
    n := UpDown2.Position + 1;

  Maxx := 0;
  for i := 0 to n - 1 do
  begin
    if FrequencyD[i] > Maxx then
      Maxx := FrequencyD[i];
  end;

  try
    V := StrToInt(Edit9.Text);
  except
    V := 1;
  end;

  if (V <= 1) or (Maxx * V > MaxFreqMax) then
  begin
    ShowMessage(Edit9.Text + ' |鎖͏o܂B');
    Edit9.Text := '2';
    Exit;
  end;

  j := Length(FrequencyD);
  n := UpDown2.Position + 1;

  if j < n then
  begin
    SetLength(FrequencyD, n);
    for i := j to n - 1 do
      FrequencyD[i] := 0; // 
  end;

  for i := 0 to n - 1 do
    FrequencyD[i] := FrequencyD[i] * V; // 0 ` UpDown2.Position ̗vf V |B

  Button4Click(Sender);
end;

procedure TFrameForm.Button8Click(Sender: TObject);
var
  i, j, n, V: Integer;
begin
  try
    V := StrToInt(Edit10.Text);
  except
    V := 1;
  end;

  if V <= 1 then
  begin
    ShowMessage(Edit10.Text + ' Ŋ鎖͏o܂B');
    Edit10.Text := '2';
    Exit;
  end;

  j := Length(FrequencyD);
  n := UpDown2.Position + 1;

  if j < n then
  begin
    SetLength(FrequencyD, n);
    for i := j to n - 1 do
      FrequencyD[i] := 0; // 
  end;

  for i := 0 to n - 1 do
    FrequencyD[i] := FrequencyD[i] div V; // 0 ` UpDown2.Position ̗vf V ŊB

  Button4Click(Sender);
end;

procedure TFrameForm.Edit7KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button5Click(Sender);
end;

procedure TFrameForm.Edit8KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button6Click(Sender);
end;

procedure TFrameForm.Edit9KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button7Click(Sender);
end;

procedure TFrameForm.Edit10KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button8Click(Sender);
end;

procedure TFrameForm.Button9Click(Sender: TObject);
begin
  if Button12.Tag <> 0 then
  begin
    Button12.Tag := 0;
    Button12.Caption := 'A = ' + IntToStr(Button12.Tag);
  end;

  if RadioButton1.Checked then
    DispBarGraph(FrequencyD, LenD, SIndex, True)
  else
    DispBarGraph(FrequencyF, LenF, SIndex, True);
end;

procedure TFrameForm.Button10Click(Sender: TObject);
begin
  if RadioButton1.Checked then
    DispBarGraph(FrequencyD, LenD, SIndex, False)
  else
    DispBarGraph(FrequencyF, LenF, SIndex, False);
  Button10.Enabled := False;
  Button11.Enabled := False;
  Button12.Enabled := False;
end;

procedure TFrameForm.Button11Click(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to LenD - 1 do // ݕ\Ă镔Rs[B
    FrequencyD[i] := Normal[i];

  for i := LenD to Length(FrequencyD) - 1 do
    FrequencyD[i] := 0;

  Button4Click(Sender);

  if RadioButton2.Checked then
    RadioButton1.Checked := True;
end;

procedure TFrameForm.X1Click(Sender: TObject);
begin
  X1.Checked := not X1.Checked;

  Memo1.Clear;
  if X1.Checked then
    Memo1.Lines.Add('Huffman Generator ̓dN\Ƃ܂B' + #13#10 +
                    'ȌA Huffman Generator ̋N\ƂȂ܂B')
  else
    Memo1.Lines.Add('Huffman Generator ̓dNs\Ƃ܂B' + #13#10 +
                    'ȌAHuffman Generator N邲ƂɒOɋN' + #13#10 +
                    'Huffman Generator I܂B');

  Parameter1.VBools['X1.Checked'] := X1.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.Edit13KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  X: Integer;
begin
  if Key = $0D then
  begin
    try
      X := StrToInt(Edit13.Text);
    except
      X := MaxFreq;
      Edit13.Text := IntToStr(X);
    end;

    if X > 32767 then
      UpDown6.Associate := Nil
    else
    begin
      UpDown6.Associate := Edit13;
      UpDown6.Position := X;
    end;
  end;
end;

procedure TFrameForm.RadioButton5Click(Sender: TObject);
begin
  Memo1.Text := SFreq;
end;

function TFrameForm.GetTotal(Frequency: array of Integer; L, R: Integer): Int64;
var
  i: Integer;
begin
  { Frequency[]  L ` R Ԃ̗vf̍v߂B}

  Result := -1;
  if (L < 0) or (R > Length(Frequency) - 1) or (L > R) then
    Exit;

  for i := L to R do
    Result := Result + Frequency[i];
end;

function TFrameForm.GetEX(Frequency: array of Integer; L, R: Integer): Integer;
var
  i: Integer;
  TT, Sum: Int64;
begin
  { Frequency[]  L ` R Ԃ̕ς߂B}

  Result := -1;
  if (L < 0) or (R > Length(Frequency) - 1) or (L > R) then
    Exit;

  TT := GetTotal(Frequency, L, R);
  Sum := 0;
  for i := L to R do
  begin
    Sum := Sum + i * Frequency[i];
  end;
  Result := Sum div TT;
end;

function TFrameForm.GetVX(Frequency: array of Integer; L, R, EX: Integer): Integer;
var
  i, X: Integer;
  TT, Sum: Int64;
begin
  { ς EX Ƃꍇ Frequency[]  L ` R Ԃ̕U߂B}

  Result := -1;
  Sum := 0;
  if (L < 0) or (R > Length(Frequency) - 1) or (L > R) then
    Exit;

  TT := GetTotal(Frequency, L, R);
  for i := L to R do
  begin
    X := (i - EX) * (i - EX) * Frequency[i];
    Sum := Sum + X;
  end;
  Result := Sum div TT;
end;

function TFrameForm.GetpLeft(Frequency: array of Integer; Per: Integer): Integer;
var
  TT, Sum: Int64;
begin
  { Frequency[]  [ Per % ߂B}

  Result := -1;
  Sum := 0;
  if (Per < 1) or (Per > 49) then
    Exit;

  TT := GetTotal(Frequency, 0, Length(Frequency) - 1);
  Result := 0;
  while Result <= iMaxFreq do
  begin
    Sum := Sum + Frequency[Result];
    if (Sum * 100 div TT) >= Per then
      Break;
    Inc(Result);
  end;
end;

function TFrameForm.GetpRight(Frequency: array of Integer; Per: Integer): Integer;
var
  TT, Sum: Int64;
begin
  { Frequency[]  E[ Per % ߂B}

  Result := -1;
  Sum := 0;
  if (Per < 1) or (Per > 49) then
    Exit;

  TT := GetTotal(Frequency, 0, Length(Frequency) - 1);
  Result := Length(Frequency) - 1;
  while Result >= iMaxFreq do
  begin
    Sum := Sum + Frequency[Result];
    if (Sum * 100 div TT) >= Per then
      Break;
    Dec(Result);
  end;
end;

procedure TFrameForm.Button12Click(Sender: TObject);
var
  EX, VX, MaxF: Integer;
  L, R: Integer;
begin
  EX := 0; VX := 0;

  if LenF >= 3 then
    MaxF := (FrequencyF[0] + FrequencyF[1] + FrequencyF[2]) div 3
  else if LenF = 2 then
    MaxF := (FrequencyF[0] + FrequencyF[1]) div 2
  else
    MaxF := FrequencyF[0];

  Button12.Tag := Button12.Tag + 1;
  if Button12.Tag = 6 then
    Button12.Tag := 0;
  Button12.Caption := 'A = ' + IntToStr(Button12.Tag);

  if Button12.Tag = 0 then // ̃f[^̂܂܂ŌvZ
  begin
    EX := StrToInt(Label9.Caption);
    VX := StrToInt(Label10.Caption);
    MaxF := StrToInt(Label12.Caption);
  end
  else if Button12.Tag = 1 then // [ 5 % ̓ŌvZ
  begin
    if RadioButton1.Checked then
    begin
      L := GetpLeft(FrequencyD, 5); R := GetpRight(FrequencyD, 5);
      EX := GetEX(FrequencyD, L, R); VX := GetVX(FrequencyD, L, R, EX);
    end
    else
    begin
      L := GetpLeft(FrequencyF, 5); R := GetpRight(FrequencyF, 5);
      EX := GetEX(FrequencyF, L, R); VX := GetVX(FrequencyF, L, R, EX);
    end;
  end
  else if Button12.Tag = 2 then // ς iMaxFreq Ƃė[ 5 % ̓ŌvZ
  begin
    if RadioButton1.Checked then
    begin
      L := GetpLeft(FrequencyD, 5); R := GetpRight(FrequencyD, 5);
      EX := iMaxFreq; VX := GetVX(FrequencyD, L, R, EX);
    end
    else
    begin
      L := GetpLeft(FrequencyF, 5); R := GetpRight(FrequencyF, 5);
      EX := 0; VX := GetVX(FrequencyF, L, R, EX);
    end;
  end
  else if Button12.Tag = 3 then // ς iMaxFreq Ƃė[ 10 % ̓ŌvZ
  begin
    if RadioButton1.Checked then
    begin
      L := GetpLeft(FrequencyD, 10); R := GetpRight(FrequencyD, 10);
      EX := iMaxFreq; VX := GetVX(FrequencyD, L, R, EX); MaxF := MaxF * 9 div 10;
    end
    else
    begin
      L := GetpLeft(FrequencyF, 10); R := GetpRight(FrequencyF, 10);
      EX := 0; VX := GetVX(FrequencyF, L, R, EX); MaxF := MaxF * 9 div 10;
    end;
  end
  else if Button12.Tag = 4 then // ς L Ƃė[ 5 % ̓ŌvZ
  begin
    if RadioButton1.Checked then
    begin
      L := GetpLeft(FrequencyD, 5); R := GetpRight(FrequencyD, 5);
      EX := L; VX := GetVX(FrequencyD, L, R, EX);
    end
    else
    begin
      L := GetpLeft(FrequencyF, 5); R := GetpRight(FrequencyF, 5);
      EX := L; VX := GetVX(FrequencyF, L, R, EX);
    end;
  end
  else if Button12.Tag = 5 then // ς R Ƃė[ 5 % ̓ŌvZ
  begin
    if RadioButton1.Checked then
    begin
      L := GetpLeft(FrequencyD, 5); R := GetpRight(FrequencyD, 5);
      EX := R; VX := GetVX(FrequencyD, L, R, EX);
    end
    else
    begin
      L := GetpLeft(FrequencyF, 5); R := GetpRight(FrequencyF, 5);
      EX := R; VX := GetVX(FrequencyF, L, R, EX);
    end;
  end;

  if EX < 0 then EX := 0; UpDown4.Position := EX;
  if VX < 0 then VX := 0; UpDown5.Position := VX;
  Edit13.Text := IntToStr(MaxF);

  if RadioButton1.Checked then
    DispBarGraph(FrequencyD, LenD, SIndex, True)
  else
    DispBarGraph(FrequencyF, LenF, SIndex, True);
end;

procedure TFrameForm.RadioButton6Click(Sender: TObject);
begin
  if RadioButton6.Tag = 0 then
    Button3Click(Sender)
  else
    RadioButton6.Tag := 0;
end;

procedure TFrameForm.RadioButton7Click(Sender: TObject);
begin
  Button3Click(Sender);
end;

procedure TFrameForm.Button13Click(Sender: TObject);
var
  i: Integer;
begin
  i := SIndex - Foot;
  if SIndex < 0 then
    i := 0;

  if RadioButton1.Checked then
    DispBarGraph(FrequencyD, LenD, i, False)
  else
    DispBarGraph(FrequencyF, LenF, i, False);
end;

procedure TFrameForm.Button14Click(Sender: TObject);
begin
  if RadioButton1.Checked then
    DispBarGraph(FrequencyD, LenD, SIndex + Foot, False)
  else
    DispBarGraph(FrequencyF, LenF, SIndex + Foot, False);
end;

procedure TFrameForm.FormResize(Sender: TObject);
begin
  if (CurFile = '') or (LenD = 0) then
    Exit;

  if RadioButton1.Checked then
    DispBarGraph(FrequencyD, LenD, 0, False)
  else
    DispBarGraph(FrequencyF, LenF, 0, False);
end;

end.

